VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Font Tester"
   ClientHeight    =   2910
   ClientLeft      =   1635
   ClientTop       =   1545
   ClientWidth     =   2895
   LinkTopic       =   "Form1"
   ScaleHeight     =   2910
   ScaleWidth      =   2895
   Begin VB.Frame Frame1 
      Caption         =   "Font Tester"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2775
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2775
      Begin VB.TextBox Text1 
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   1155
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   2
         Text            =   "Form1.frx":0000
         Top             =   1500
         Width           =   2535
      End
      Begin VB.ListBox List1 
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   1110
         Left            =   120
         Sorted          =   -1  'True
         TabIndex        =   1
         Top             =   240
         Width           =   2535
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Font Loading Example
' by PAT or JK
' Date: 9.25.99
' E-Mail: patorjk@aol.com
' Webpage: www.patorjk.com

' This example shows you one way you can
' speed up the loading of the fonts in one
' of your programs.

' What it does is it will save all of the fonts
' to a file. Then the next time you run the
' program it just loads the fonts that are saved
' in the file (which makes things a lot faster).
' It also checks before it loads the
' fonts in the file to see if there are any
' new fonts on the persons computer. The idea
' for this way of loading fonts originally came
' from a conversation me and this programmer
' called gozer had.

' The fonts will be saved in a file with the
' number of fonts placed at the top.

' note: there is an api way that is faster than
' the for next loop with the screen object, but
' it's a lot more code and it only saves about
' half a seconds worth of time.

Option Explicit
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Type POINTAPI
        X As Long
        Y As Long
End Type

Sub GetFontsForList()
    ' This sub adds all the fonts on the persons
    ' computer to the List1 listbox.
    Dim DaFilePath As String, i As Integer
    Dim IsDone As Boolean, lItem As String
    ' DaFilePath will store the name of the
    ' file we want to use as our font holder.
    DaFilePath = FindFilePath & "FontList.ini"
    ' see if a font file exists, if not, then
    ' create one.
    If Len(Dir(DaFilePath)) = 0 Then
        Open DaFilePath For Output As #1
            ' save the number of fonts at the
            ' top so that in the future we can
            ' check to see how many fonts
            ' there are.
            Print #1, Screen.FontCount
            For i = 0 To Screen.FontCount - 1
                Print #1, Screen.Fonts(i)
                List1.AddItem Screen.Fonts(i)
            Next
        Close #1
        ' ok, we've created a font file and
        ' loaded all of the fonts, so our job
        ' here is done.
        IsDone = True
    Else
        ' we haven't really done anything yet
        ' so our job is not yet done.
        IsDone = False
    End If
    
    ' find out if we've done or not.
    If IsDone = False Then
        Open DaFilePath For Input As #1
            ' see how many fonts are stored in
            ' the file.
            Input #1, lItem
        Close #1
        
        If Val(lItem) < Screen.FontCount Then
            ' if we find that there are more
            ' fonts than last time then we must
            ' reload all of the fonts.
            Open DaFilePath For Output As #1
                Print #1, Screen.FontCount
                For i = 0 To Screen.FontCount - 1
                    Print #1, Screen.Fonts(i)
                    List1.AddItem Screen.Fonts(i)
                Next
            Close #1
        Else
            ' There aren't any new fonts so we
            ' can just quickly load them from
            ' our saved file.
            Open DaFilePath For Input As #1
                Input #1, lItem
                For i = 1 To Val(lItem)
                    Input #1, lItem
                    List1.AddItem lItem
                Next
            Close #1
        End If
    End If
End Sub

Function FindFilePath() As String
    ' This function will return the path of
    ' the program.
    Dim ThePath As String
    ThePath = App.Path
    If Right(ThePath, 1) <> "\" Then
        ThePath = ThePath & "\"
    End If
    FindFilePath = ThePath
End Function

Private Sub Form_Load()
    ' we don't want to fill up the load event
    ' of the form with the font getting code,
    ' so we'll store that code in a sub and
    ' then call it from the form's load event.
    Call GetFontsForList
End Sub

Private Sub List1_Click()
    ' When someone clicks on an item in the
    ' listbox change the textbox's font to
    ' the font selected.
    Text1.Font = List1.List(List1.ListIndex)
    Text1.FontItalic = False
    Text1.FontBold = False
    Text1.FontSize = 8
End Sub

